#!/bin/ash

# allow env to override nvram
nvram () {
	case $1 in
		get) eval "echo \${NVRAM_$2:-\$(command nvram get $2)}";;
		*) command nvram $*;;
	esac
}
. /etc/nvram.overrides

wdev="$(l=$(grep : /proc/net/wireless);l=${l%:*};echo ${l##* })"
test -n "$wdev" && export NVRAM_wifi_ifname=$wdev

# valid interface?
if_valid () {
	ip link show dev "$1" >&- 2>&- ||
	[ "${1%%[0-9]}" = "br" ] ||
	{
		[ "${1%%[0-9]}" = "vlan" ] && ( 
			i=${1#vlan}
			vif=$(ls /proc/switch 2>&-|cut -d' ' -f1)
			hwname=$(nvram get vlan${i}hwname)
			hwaddr=$(nvram get ${hwname}macaddr)
			if [ -z "$hwaddr" ]; then
				vports=$(cat /proc/switch/$vif/vlan/$i/ports 2>&-)
				test -n "$vif" && test 1 -lt ${#vports} && test -n "$(nvram get 'vlan'$i'ports')" || return 1
			fi
			ip link set dev $vif up
			vconfig add $vif $i 2>&-
		)
	} ||
	{ echo -e "# $1 ignored: can't find/create"; false; }
}
